<template>
  <el-dialog
    :visible="dialogVisible"
    width="70%"
    style="height: 98%"
    :before-close="handleClose"
    top="5vh"
    lock-scroll
  >
    <div class="title" slot="title">
      <div class="divider"></div>
      <span class="label">导入记录</span>
    </div>
    <div class="upload-progress">
      <div class="top-bar">
        <SearchBar :config="searchConfig" @search="search" @reset="reset" />
      </div>
      <TablePage
        :data="list.records"
        :tableTitle="tableTitle"
        :operates="tableOperates"
      >
        <template v-slot:fileSize="scope">
          {{ getFileSize(scope.scope.fileSize) }}
        </template>
        <template v-slot:operates="scope">
          <TableOperation
            :operations="tableOperations"
            :rawData="scope.scope.row"
            @handleOperation="handleOperation"
          ></TableOperation>
        </template>
      </TablePage>
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="Number(list.current)"
        :page-sizes="[10, 20, 40, 50]"
        :page-size="Number(list.size)"
        layout="total, sizes, prev, pager, next, jumper"
        :total="Number(list.total)"
        class="pagination"
      >
      </el-pagination>
    </div>
    <div class="dialog-footer">
      <el-button type="primary" @click.native="handleClose" >关闭</el-button>
    </div>
  </el-dialog>
</template>

<script>
import TablePage from "@/components/Table/TablePage.vue";
import TableOperation from "@/components/Table/TableOperation.vue";
import { importRecordsTitle, importOperates, importOperations } from "../config";
import { getImportListPage, deleteByBatchNum } from "@/api/file";
import SearchBar from "@/components/SearchBar";
export default {
  name: "ImportRecordDialog",
  components: {
    TablePage,
    TableOperation,
    SearchBar,
  },
  props: {
    visible: {
      type: Boolean,
      default: false,
    },
    filesList: {
      type: Array,
      default: () => [],
    },
  },
  watch: {
    visible: {
      handler: function (value) {
        this.dialogVisible = value;
      },
      deep: true,
      immediate: true,
    },
  },
  computed: {
    tableTitle() {
      return importRecordsTitle;
    },
    tableOperates() {
      return importOperates;
    },
    tableOperations() {
      return importOperations;
    },
    getFileSize(fileSize) {
      return (fileSize) => {
        return (Number(fileSize) / 1024 / 1024).toFixed(2) + "M";
      };
    },
  },
  data() {
    return {
      dialogVisible: false,
      list: {
        records: [],
        size: 10,
        current: 1,
        total: 0,
      },
      searchForm: {
        name: "",
        status: "",
      },
      searchConfig: [
        // {
        //   prop: "type",
        //   type: "select",
        //   label: "所属分类",
        //   selectOptions: [
        //     {
        //       label: "文物",
        //       value: "biz_cultural_relic",
        //     },
        //     {
        //       label: "展览",
        //       value: "biz_exhibition",
        //     },
        //   ],
        // },
        {
          prop: "batchNum",
          type: "input",
          label: "批次",
        },
      ],
    };
  },
  mounted() {
    this.loadData();
  },
  methods: {
    async search(form) {
      var params = {
        page: this.list.current,
        limit: this.list.size,
        ...form,
      };
      let res = await getImportListPage(params);
      if (res.code == 0) {
        this.list = res.data;
      }
    },

    reset() {
      this.loadData();
    },

    //   加载表格数据
    async loadData() {
      var params = {
        page: this.list.current,
        limit: this.list.size,
      };
      let res = await getImportListPage(params);
      if (res.code == 0) {
        this.list = res.data;
      }
    },
    async handleOperation(value, row) {
      console.log("handleOperation", value, row);
      switch (value.type) {
        case "add":
          this.editVisible = true;
          break;
        case "view":
          break;
        case "delete":
          let { batchNum, type,id } = row;
          let deleteRes = await deleteByBatchNum({ batchNum, type });
          if (deleteRes.code == 0) {
            this.$message.success("删除成功！");
            this.loadData();
          }
          break;
      }
    },

    // 改变页容量
    handleSizeChange(value) {
      this.list.size = value;
      this.loadData();
    },

    // 改变当前显示页
    handleCurrentChange(value) {
      this.list.current = value;
      this.loadData();
    },


    handleClose() {
      this.$emit("handleClose");
    },
  },
};
</script>

<style lang='scss' scoped>
.title {
  display: flex;
  .divider {
    width: 8px;
    height: 16px;
    border-left: 4px solid #409eff;
    margin-right: 8px;
  }
  .label {
    font-weight: bold;
  }
}
.dialog-content {
  padding: 0 32px;
  display: flex;
  flex-direction: column;
}

.dialog-footer {
  margin-top: 30px;
  display: flex;
  justify-content: flex-end;
}
.el-dialog__body {
  padding: 0 20px 30px 20px;
}

.top-bar {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 10px;
}
.pagination {
  margin: 16px;
}
</style>